stages:
  - build
  - testing
  - remote
  - 🛸
  - 🪆

🐳_docker_image:
  stage: build
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  variables:
    JSON_CONFIG: |
      {
        "auths": {
          "$CI_REGISTRY": {
            "username": "$CI_REGISTRY_USER",
            "password": "$CI_REGISTRY_PASSWORD"
          }
        }
      }
  script: |
    echo "${JSON_CONFIG}" > /kaniko/.docker/config.json
    /kaniko/executor \
      --context $CI_PROJECT_DIR \
      --dockerfile $CI_PROJECT_DIR/Dockerfile \
      --destination $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
    - if: $CI_MERGE_REQUEST_IID


🛂_test-api:
  stage: testing
  tags: [saas-linux-small-amd64]
  needs: ["🐳_docker_image"]
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
    - if: $CI_MERGE_REQUEST_IID
  services: # use services to link your app container to the job
    - name: $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA
      alias: webapp
  script:
    - curl http://webapp:8080/api/hello
    - curl http://webapp:8080/api/hello
    - curl http://webapp:8080/api/hello

dumb_job:
  stage: build
  script: echo "Doing nothing ⏳"
  tags:
    - local

trigger_job:
  stage: remote
  trigger:
    # changer xxx avec votre nom d'espace personnel
    project: gitlabuniversity/solutions/devoxx-2023/web-app

🥸_generate-mustache:
  image: golang
  stage: 🛸
  before_script: 
    - go install github.com/cbroglie/mustache/cmd/mustache@latest
  script: mustache data.json ci.template > generated-ci.yml
  artifacts:
    paths:
      - generated-ci.yml
  needs:
    - []

👶_child-pipelines:
  stage: 🪆
  trigger:
    include:
      - artifact: generated-ci.yml
        job: 🥸_generate-mustache
